package com.ctjsoft.bsw.center.clct.hilist.service.impl;

package ..deTemp.1749704289255;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ctjsoft.bsw.center.clct.hilist.entity.ApiType;
import com.ctjsoft.bsw.center.clct.hilist.entity.HilistInfo;
import com.ctjsoft.bsw.center.clct.hilist.entity.HilistTypeInfo;
import com.ctjsoft.bsw.center.clct.hilist.entity.MedResultDTO;
import com.ctjsoft.bsw.center.clct.hilist.entity.MedResultDownloadDTO;
import com.ctjsoft.bsw.center.clct.hilist.entity.MedUpldDataInfo;
import com.ctjsoft.bsw.center.clct.hilist.entity.MedUpldInfo;
import com.ctjsoft.bsw.center.clct.hilist.entity.UpldInfo;
import com.ctjsoft.bsw.center.clct.hilist.mapper.HilistInfoMapper;
import com.ctjsoft.bsw.center.clct.hilist.mapper.HilistTypeInfoMapper;
import com.ctjsoft.bsw.center.clct.hilist.service.IHilistInfoService;
import com.ctjsoft.bsw.center.clct.syscfgmgt.tfpintfparacfg.entity.TfpIntfParaCfg;
import com.ctjsoft.bsw.center.clct.syscfgmgt.tfpintfparacfg.service.ITfpIntfParaCfgService;
import com.ctjsoft.bsw.center.clct.upldtaskexe.service.IReqtEbcService;
import com.ctjsoft.bsw.center.clct.upldtaskexe.service.IUpldReqService;
import com.ctjsoft.bsw.connector.upld.entity.AdapterBusiness;
import com.ctjsoft.bsw.toolkit.constant.CommonConstant;
import com.ctjsoft.bsw.toolkit.entity.StandardOutput;
import com.ctjsoft.bsw.toolkit.enums.ResultCodeEnum;
import com.ctjsoft.bsw.toolkit.exception.BswException;
import com.ctjsoft.bsw.toolkit.utils.DateUtil;
import com.ctjsoft.bsw.toolkit.utils.JsonUtils;
import com.ctjsoft.bsw.toolkit.utils.StringUtil;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.lang.invoke.SerializedLambda;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Objects;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import javax.annotation.Resource;
import org.apache.commons.lang3.ArrayUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.system.vo.LoginUser;
import org.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;

@Service
@Transactional
public class HilistInfoServiceImpl extends ServiceImpl<HilistInfoMapper, HilistInfo> implements IHilistInfoService {
  @Resource
  private HilistInfoMapper hilistInfoMapper;
  
  private static final Logger logger = LoggerFactory.getLogger(com.ctjsoft.bsw.center.clct.hilist.service.impl.HilistInfoServiceImpl.class);
  
  @Autowired
  private ITfpIntfParaCfgService tfpIntfParaCfgService;
  
  @Autowired
  private HilistTypeInfoMapper hilistTypeInfoMapper;
  
  @Autowired
  private IReqtEbcService reqtEbcService;
  
  @Autowired
  private IUpldReqService upldService;
  
  @Value("${clctBill.clctMedSerVer:F002}")
  private String clctMedSerVer;
  
  @Value("${clctBill.clctMedicineVer:0}")
  private String clctMedicineVer;
  
  private static final Logger LOGGER = LoggerFactory.getLogger(com.ctjsoft.bsw.center.clct.hilist.service.impl.HilistInfoServiceImpl.class);
  
  public List<HilistInfo> getHilistInfo(List<String> hilistCodeList) {
    if (CollectionUtils.isEmpty(hilistCodeList))
      return null; 
    return this.hilistInfoMapper.getByCodes(hilistCodeList);
  }
  
  public IPage<HilistInfo> query(HilistInfo hilistCode) {
    Page page = new Page(hilistCode.getPageNo().intValue(), hilistCode.getPageSize().intValue());
    IPage<HilistInfo> resultList = null;
    try {
      if (CommonConstant.NUM_COMMON_1.equals(hilistCode.getStas())) {
        resultList = this.hilistInfoMapper.queryHilistCode(page, hilistCode.getHilistCode(), hilistCode.getHilistName(), hilistCode.getTypeInfoId());
      } else {
        resultList = this.hilistInfoMapper.queryHilistCodeLog(page, hilistCode.getHilistCode(), hilistCode.getHilistName(), hilistCode.getTypeInfoId());
      } 
    } catch (Exception e) {
      logger.error("查询医保目录失败, 失败原因:{}", e.getMessage(), e);
      throw new BswException(ResultCodeEnum.SQL_ERROR.getCode(), "查询医保目录失败");
    } 
    return resultList;
  }
  
  @Transactional(propagation = Propagation.REQUIRES_NEW, rollbackFor = {Exception.class})
  public String requestdeal(String version, ApiType apiType, HilistTypeInfo hilistTypeInfo, HilistTypeInfo hilistTypeHis, String typeFlage) throws Exception {
    List<HilistInfo> addList = new ArrayList<>();
    String ver = null;
    MedResultDTO medResultDTO = dealUpldElecSetlCert(version, apiType.getUrl());
    if (Objects.isNull(medResultDTO))
      return ver; 
    byte[] bytes = dealdown(medResultDTO);
    List<HilistInfo> westernList = parseZipFile(bytes, apiType);
    if (!CollectionUtils.isEmpty(westernList)) {
      int type = apiType.getListType();
      dealData(westernList, addList, hilistTypeInfo.getTypeInfoId().longValue(), type);
      ver = ((HilistInfo)westernList.get(CommonConstant.NUM_COMMON_0.intValue())).getVer();
    } 
    if (!CollectionUtils.isEmpty(addList)) {
      batchInsertHilist(addList);
      if (Objects.isNull(hilistTypeHis) && "1".equals(typeFlage)) {
        hilistTypeInfo.setHilistVer(((HilistInfo)westernList.get(CommonConstant.NUM_COMMON_0.intValue())).getVer());
        hilistTypeInfo.setVer(((HilistInfo)westernList.get(CommonConstant.NUM_COMMON_0.intValue())).getVer());
        this.hilistTypeInfoMapper.insert(hilistTypeInfo);
      } else {
        LambdaUpdateWrapper<HilistTypeInfo> wrapper = new LambdaUpdateWrapper();
        wrapper.eq(HilistTypeInfo::getTypeInfoId, hilistTypeInfo.getTypeInfoId());
        wrapper.set(HilistTypeInfo::getUpdtTime, DateUtil.nowDatetime());
        wrapper.set(HilistTypeInfo::getVer, ((HilistInfo)westernList.get(CommonConstant.NUM_COMMON_0.intValue())).getVer());
        wrapper.set(HilistTypeInfo::getHilistVer, ((HilistInfo)westernList.get(CommonConstant.NUM_COMMON_0.intValue())).getVer());
        this.hilistTypeInfoMapper.update(null, (Wrapper)wrapper);
      } 
      logger.info(String.format("医保业务编码库类别:%s版本号:%s,数据已保存两定返回数据;处理条数:%s", new Object[] { apiType.getApiName(), ver, Integer.valueOf(addList.size()) }));
    } 
    return ver;
  }
  
  public void dealData(List<HilistInfo> westernList, List<HilistInfo> addList, long typeId, int listType) {
    for (HilistInfo hilistInfo : westernList)
      hilistInfo.setTypeInfoId(Long.valueOf(typeId)); 
    addList.addAll(westernList);
  }
  
  public ApiType[] getApiType() {
    ApiType[] apiTypes = { ApiType.WESTERN_MEDICINE, ApiType.CHINESE_MEDICINE, ApiType.MEDICAL_INSTITUTION, ApiType.ETHNIC_MEDICINE, ApiType.MEDICAL_SERVICE };
    return apiTypes;
  }
  
  public MedResultDTO dealUpldElecSetlCert(String ver, String url) {
    MedResultDTO output = null;
    List<TfpIntfParaCfg> tfpIntfParaCfgs = this.tfpIntfParaCfgService.querylist();
    TfpIntfParaCfg tfpIntfPara = tfpIntfParaCfgs.get(0);
    try {
      MedUpldDataInfo medUpldDataInfo = new MedUpldDataInfo();
      MedUpldInfo medUpldInfo = new MedUpldInfo();
      medUpldInfo.setVer(ver);
      medUpldDataInfo.setData(medUpldInfo);
      AdapterBusiness adapterBusiness = this.reqtEbcService.initAdapterBusinessDTO(medUpldDataInfo, tfpIntfPara, url);
      adapterBusiness.setInsuplcAdmdvs(tfpIntfPara.getMdtrtareaAdmvs());
      StandardOutput adapter = this.upldService.adapter(adapterBusiness);
      if (adapter == null)
        throw new BswException("数据返回空"); 
      if (StringUtils.isNotBlank(adapter.getErr_msg()) && 
        adapter.getErr_msg().contains("FSI") && adapter.getErr_msg().contains("最新数据")) {
        logger.info(String.format("版本号:%s,已处理是最新数据;返回异常信息:%s", new Object[] { url, adapter.getErr_msg() }));
        return output;
      } 
      output = new MedResultDTO();
      output = (MedResultDTO)JsonUtils.objcetToObjectOfType(adapter.getOutput(), MedResultDTO.class);
    } catch (Exception e) {
      throw new BswException(String.format("%s目录下载失败,版本号:%s,定点医疗机构编码:%s,异常信息:%s", new Object[] { url, ver, tfpIntfPara
              .getFixmedinsCode(), e.getMessage() }), e);
    } 
    return output;
  }
  
  public byte[] dealdown(MedResultDTO medResultDTO) {
    List<TfpIntfParaCfg> tfpIntfParaCfgs = this.tfpIntfParaCfgService.querylist();
    TfpIntfParaCfg tfpIntfPara = tfpIntfParaCfgs.get(0);
    byte[] adapter = null;
    try {
      MedResultDownloadDTO medResultDownloadDTO = new MedResultDownloadDTO();
      UpldInfo medUpldInfo = new UpldInfo();
      medUpldInfo.setFilename(medResultDTO.getFilename());
      medUpldInfo.setFile_qury_no(medResultDTO.getFile_qury_no());
      medUpldInfo.setFixmedins_code(tfpIntfPara.getFixmedinsCode());
      medResultDownloadDTO.setFsDownloadIn(medUpldInfo);
      AdapterBusiness adapterBusiness = this.reqtEbcService.initAdapterBusinessDTO(medResultDownloadDTO, tfpIntfPara, "9102");
      adapterBusiness.setInsuplcAdmdvs(tfpIntfPara.getMdtrtareaAdmvs());
      adapter = this.upldService.down(adapterBusiness);
      if (adapter == null)
        throw new BswException(String.format("文件下载失败,文件名称:%s,文件查询号:%s,医药机构编号:%s,异常原因:响应值为空", new Object[] { medResultDTO.getFilename(), medResultDTO
                .getFile_qury_no(), tfpIntfPara.getFixmedinsCode() })); 
    } catch (Exception e) {
      throw new BswException(String.format("文件下载失败,文件名称:%s,文件查询号:%s,医药机构编号:%s,异常信息:%s", new Object[] { medResultDTO.getFilename(), medResultDTO
              .getFile_qury_no(), tfpIntfPara.getFixmedinsCode(), e.getMessage() }));
    } 
    return adapter;
  }
  
  private String removeOtherNode(String jsonStr) {
    if (StringUtil.isBlank(jsonStr))
      return null; 
    JSONObject jsonObject = new JSONObject(jsonStr);
    jsonObject.remove("other");
    String ext = jsonObject.toString();
    if (StringUtil.isEmpty(ext) || ext.equals("{}"))
      return null; 
    return ext;
  }
  
  public static List<HilistInfo> parseZipFile(byte[] bytes, ApiType apiType) {
    List<HilistInfo> list = null;
    if (ArrayUtils.isNotEmpty(bytes)) {
      ByteArrayInputStream bInputStream = new ByteArrayInputStream(bytes);
      ZipInputStream zipInputStream = null;
      try (ZipInputStream zis = new ZipInputStream(bInputStream, Charset.forName("GBK"))) {
        ZipEntry zipEntry = zis.getNextEntry();
        while (zipEntry != null) {
          if (!zipEntry.isDirectory() && zipEntry.getName().endsWith(".txt"))
            list = parseTxtFile(zis, apiType); 
          zipEntry = zis.getNextEntry();
        } 
      } catch (IOException e) {
        e.printStackTrace();
      } 
    } 
    return list;
  }
  
  private static List<HilistInfo> parseTxtFile(ZipInputStream zis, ApiType apiType) throws IOException {
    List<HilistInfo> list = new ArrayList<>();
    BufferedReader reader = new BufferedReader(new InputStreamReader(zis));
    Date date = DateUtil.nowDatetime();
    String line;
    while ((line = reader.readLine()) != null) {
      String[] columns = line.split("\t");
      if (columns.length > Math.max(apiType.getCodeIndex(), Math.max(apiType.getNameIndex(), apiType.getVersionIndex()))) {
        String medicalCode = columns[apiType.getCodeIndex()];
        String medicalName = columns[apiType.getNameIndex()];
        String version = columns[apiType.getVersionIndex()];
        String valiFlag = columns[apiType.getValiFlag()];
        if ("1".equals(valiFlag)) {
          HilistInfo hilistInfo = new HilistInfo();
          hilistInfo.setInfoId(Long.valueOf(IdWorker.getId()));
          hilistInfo.setHilistCode(medicalCode);
          hilistInfo.setHilistName("null".equals(medicalName) ? null : medicalName);
          hilistInfo.setVer(version);
          hilistInfo.setCrteTime(date);
          hilistInfo.setUpdtTime(date);
          hilistInfo.setListType(Integer.valueOf(apiType.getListType()));
          list.add(hilistInfo);
        } 
      } 
    } 
    return list;
  }
  
  public void batchInsertHilist(List<HilistInfo> list) {
    int batchSize = 1000;
    for (int i = 0; i < list.size(); i += batchSize) {
      int end = Math.min(i + batchSize, list.size());
      this.hilistInfoMapper.saveBatchListCode(list.subList(i, end));
      try {
        Thread.sleep(50L);
      } catch (InterruptedException e) {
        Thread.currentThread().interrupt();
      } 
    } 
  }
  
  public void batchUpdateHilistInfo(List<HilistInfo> fullList) {
    int total = fullList.size();
    int batchSize = 1000;
    int i;
    for (i = 0; i < total; i += batchSize) {
      int end = Math.min(i + batchSize, total);
      List<HilistInfo> batchList = fullList.subList(i, end);
      this.hilistInfoMapper.updateBatchByTypeId(fullList);
      try {
        Thread.sleep(50L);
      } catch (InterruptedException e) {
        Thread.currentThread().interrupt();
      } 
    } 
  }
  
  private void initHilistType(HilistTypeInfo hilistTypeInfo) {
    LoginUser sysUser = (LoginUser)SecurityUtils.getSubject().getPrincipal();
    ApiType apiType = ApiType.getApiType(hilistTypeInfo.getListType().intValue());
    hilistTypeInfo.setTypeInfoId(Long.valueOf(IdWorker.getId()));
    hilistTypeInfo.setStas(CommonConstant.NUM_COMMON_1);
    hilistTypeInfo.setUpdtTime(DateUtil.nowDatetime());
    hilistTypeInfo.setCrteTime(DateUtil.nowDatetime());
    hilistTypeInfo.setCrteName(sysUser.getRealname());
    hilistTypeInfo.setCrteId(sysUser.getId());
    hilistTypeInfo.setTypeInfoName(apiType.getApiName());
    hilistTypeInfo.setIsuDate(DateUtil.getNowDate());
  }
}
